ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
Revision: 2.21
Committed: Wed Jun 8 23:16:47 2011 UTC (12 years, 10 months ago) by greg
Content type: text/plain
Branch: MAIN
Changes since 2.20: +3 -2 lines
Log Message:
Added commas after each data value for WINDOW 6 compatibility

File Contents

# Content
1 #!/usr/bin/perl -w
2 # RCSid $Id: genBSDF.pl,v 2.20 2011/06/04 00:33:53 greg Exp $
3 #
4 # Compute BSDF based on geometry and material description
5 #
6 # G. Ward
7 #
8 use strict;
9 use File::Temp qw/ :mktemp /;
10 sub userror {
11 print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
12 exit 1;
13 }
14 my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15 chomp $td;
16 my @savedARGV = @ARGV;
17 my $tensortree = 0;
18 my $ttlog2 = 4;
19 my $nsamp = 1000;
20 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
21 my $mgfin = 0;
22 my $geout = 1;
23 my $nproc = 1;
24 my $doforw = 0;
25 my $doback = 1;
26 my @dim;
27 # Get options
28 while ($#ARGV >= 0) {
29 if ("$ARGV[0]" =~ /^[-+]m/) {
30 $mgfin = ("$ARGV[0]" =~ /^\+/);
31 } elsif ("$ARGV[0]" eq "-r") {
32 $rtargs = "$rtargs $ARGV[1]";
33 shift @ARGV;
34 } elsif ("$ARGV[0]" =~ /^[-+]g/) {
35 $geout = ("$ARGV[0]" =~ /^\+/);
36 } elsif ("$ARGV[0]" =~ /^[-+]f/) {
37 $doforw = ("$ARGV[0]" =~ /^\+/);
38 } elsif ("$ARGV[0]" =~ /^[-+]b/) {
39 $doback = ("$ARGV[0]" =~ /^\+/);
40 } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
41 $tensortree = substr($ARGV[0], 2, 1);
42 $ttlog2 = $ARGV[1];
43 shift @ARGV;
44 } elsif ("$ARGV[0]" eq "-c") {
45 $nsamp = $ARGV[1];
46 shift @ARGV;
47 } elsif ("$ARGV[0]" eq "-n") {
48 $nproc = $ARGV[1];
49 shift @ARGV;
50 } elsif ("$ARGV[0]" =~ /^-d/) {
51 userror() if ($#ARGV < 6);
52 @dim = @ARGV[1..6];
53 shift @ARGV for (1..6);
54 } elsif ("$ARGV[0]" =~ /^[-+]./) {
55 userror();
56 } else {
57 last;
58 }
59 shift @ARGV;
60 }
61 # Check that we're actually being asked to do something
62 die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
63 # Name our own persist file?
64 my $persistfile;
65 if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
66 $persistfile = "$td/pfile.txt";
67 $rtargs = "-PP $persistfile $rtargs";
68 }
69 # Get scene description and dimensions
70 my $radscn = "$td/device.rad";
71 my $mgfscn = "$td/device.mgf";
72 my $octree = "$td/device.oct";
73 if ( $mgfin ) {
74 system "mgfilt '#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus' @ARGV > $mgfscn";
75 die "Could not load MGF input\n" if ( $? );
76 system "mgf2rad $mgfscn > $radscn";
77 } else {
78 system "xform -e @ARGV > $radscn";
79 die "Could not load Radiance input\n" if ( $? );
80 system "rad2mgf $radscn > $mgfscn" if ( $geout );
81 }
82 if ($#dim != 5) {
83 @dim = split ' ', `getbbox -h $radscn`;
84 }
85 print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
86 # Add receiver surfaces (rectangular)
87 my $fmodnm="receiver_face";
88 my $bmodnm="receiver_behind";
89 open(RADSCN, ">> $radscn");
90 print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
91 print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
92 print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
93 print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
94 close RADSCN;
95 # Generate octree
96 system "oconv -w $radscn > $octree";
97 die "Could not compile scene\n" if ( $? );
98 # Output XML prologue
99 print
100 '<?xml version="1.0" encoding="UTF-8"?>
101 <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
102 ';
103 print "<!-- File produced by: genBSDF @savedARGV -->\n";
104 print
105 '<WindowElementType>System</WindowElementType>
106 <Optical>
107 <Layer>
108 <Material>
109 <Name>Name</Name>
110 <Manufacturer>Manufacturer</Manufacturer>
111 ';
112 printf "\t\t<Thickness unit=\"Meter\">%.3f</Thickness>\n", $dim[5] - $dim[4];
113 printf "\t\t<Width unit=\"Meter\">%.3f</Width>\n", $dim[1] - $dim[0];
114 printf "\t\t<Height unit=\"Meter\">%.3f</Height>\n", $dim[3] - $dim[2];
115 print "\t\t<DeviceType>Integral</DeviceType>\n";
116 # Output MGF description if requested
117 if ( $geout ) {
118 print "\t\t<Geometry format=\"MGF\" unit=\"Meter\">\n";
119 printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
120 open(MGFSCN, "< $mgfscn");
121 while (<MGFSCN>) { print $_; }
122 close MGFSCN;
123 print "xf\n";
124 print "\t\t</Geometry>\n";
125 }
126 print " </Material>\n";
127 # Set up surface sampling
128 my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
129 my $ny = int($nsamp/$nx + .5);
130 $nsamp = $nx * $ny;
131 my $ns = 2**$ttlog2;
132 my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
133 # Create data segments (all the work happens here)
134 if ( $tensortree ) {
135 do_tree_bsdf();
136 } else {
137 do_matrix_bsdf();
138 }
139 # Output XML epilogue
140 print
141 '</Layer>
142 </Optical>
143 </WindowElement>
144 ';
145 # Clean up temporary files and exit
146 if ( $persistfile && open(PFI, "< $persistfile") ) {
147 while (<PFI>) {
148 s/^[^ ]* //;
149 kill('ALRM', $_);
150 last;
151 }
152 close PFI;
153 }
154 exec("rm -rf $td");
155
156 #-------------- End of main program segment --------------#
157
158 #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
159 sub do_tree_bsdf {
160 # Get sampling rate and subdivide task
161 my $ns2 = $ns;
162 $ns2 /= 2 if ( $tensortree == 3 );
163 @pdiv = (0, int($ns2/$nproc));
164 my $nrem = $ns2 % $nproc;
165 for (my $i = 1; $i < $nproc; $i++) {
166 my $nv = $pdiv[$i] + $pdiv[1];
167 ++$nv if ( $nrem-- > 0 );
168 push @pdiv, $nv;
169 }
170 die "Script error 1" if ($pdiv[-1] != $ns2);
171 # Shirley-Chiu mapping from unit square to disk
172 $sq2disk = '
173 in_square_a = 2*in_square_x - 1;
174 in_square_b = 2*in_square_y - 1;
175 in_square_rgn = if(in_square_a + in_square_b,
176 if(in_square_a - in_square_b, 1, 2),
177 if(in_square_b - in_square_a, 3, 4));
178 out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
179 -in_square_a, -in_square_b);
180 out_disk_phi = PI/4 * select(in_square_rgn,
181 in_square_b/in_square_a,
182 2 - in_square_a/in_square_b,
183 4 + in_square_b/in_square_a,
184 if(in_square_b*in_square_b,
185 6 - in_square_a/in_square_b, 0));
186 Dx = out_disk_r*cos(out_disk_phi);
187 Dy = out_disk_r*sin(out_disk_phi);
188 Dz = sqrt(1 - out_disk_r*out_disk_r);
189 ';
190 # Shirley-Chiu mapping from unit disk to square
191 $disk2sq = '
192 norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
193 in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
194 in_disk_phi = norm_radians(atan2(Dy, Dx));
195 in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
196 out_square_a = select(in_disk_rgn,
197 in_disk_r,
198 (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
199 -in_disk_r,
200 (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
201 out_square_b = select(in_disk_rgn,
202 in_disk_phi*in_disk_r/(PI/4),
203 in_disk_r,
204 (PI - in_disk_phi)*in_disk_r/(PI/4),
205 -in_disk_r);
206 out_square_x = (out_square_a + 1)/2;
207 out_square_y = (out_square_b + 1)/2;
208 ';
209 # Announce ourselves in XML output
210 print "\t<DataDefinition>\n";
211 print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
212 print "\t</DataDefinition>\n";
213 # Fork parallel rtcontrib processes to compute each side
214 if ( $doback ) {
215 for (my $proc = 0; $proc < $nproc; $proc++) {
216 bg_tree_rtcontrib(0, $proc);
217 }
218 while (wait() >= 0) {
219 die "rtcontrib process reported error" if ( $? );
220 }
221 ttree_out(0);
222 }
223 if ( $doforw ) {
224 for (my $proc = 0; $proc < $nproc; $proc++) {
225 bg_tree_rtcontrib(1, $proc);
226 }
227 while (wait() >= 0) {
228 die "rtcontrib process reported error" if ( $? );
229 }
230 ttree_out(1);
231 }
232 } # end of sub do_tree_bsdf()
233
234 # Run i'th rtcontrib process for generating tensor tree samples
235 sub bg_tree_rtcontrib {
236 my $pid = fork();
237 die "Cannot fork new process" unless defined $pid;
238 if ($pid > 0) { return $pid; }
239 my $forw = shift;
240 my $pn = shift;
241 my $pbeg = $pdiv[$pn];
242 my $plen = $pdiv[$pn+1] - $pbeg;
243 my $matargs = "-m $bmodnm";
244 if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
245 my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
246 "-e '$disk2sq' -bn '$ns*$ns' " .
247 "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
248 "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
249 if ( $tensortree == 3 ) {
250 # Isotropic BSDF
251 $cmd = "cnt $plen $ny $nx " .
252 "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
253 "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
254 "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
255 "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
256 "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
257 "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
258 "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
259 "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
260 "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
261 "| $cmd";
262 } else {
263 # Anisotropic BSDF
264 # Sample area vertically to improve load balance, since
265 # shading systems usually have bilateral symmetry (L-R)
266 $cmd = "cnt $plen $ns $ny $nx " .
267 "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
268 "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
269 "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
270 "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
271 "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
272 "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
273 "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
274 "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
275 "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
276 "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
277 "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
278 "| $cmd";
279 }
280 # print STDERR "Starting: $cmd\n";
281 exec($cmd); # no return; status report to parent via wait
282 die "Cannot exec: $cmd\n";
283 } # end of bg_tree_rtcontrib()
284
285 # Simplify and output tensor tree results
286 sub ttree_out {
287 my $forw = shift;
288 my $side = ("Back","Front")[$forw];
289 # Only output one transmitted distribution, preferring backwards
290 if ( !$forw || !$doback ) {
291 print
292 ' <WavelengthData>
293 <LayerNumber>System</LayerNumber>
294 <Wavelength unit="Integral">Visible</Wavelength>
295 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
296 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
297 <WavelengthDataBlock>
298 <WavelengthDataDirection>Transmission</WavelengthDataDirection>
299 <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
300 <ScatteringDataType>BTDF</ScatteringDataType>
301 <ScatteringData>
302 ';
303 system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
304 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
305 "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
306 "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
307 die "Failure running rttree_reduce" if ( $? );
308 print
309 ' </ScatteringData>
310 </WavelengthDataBlock>
311 </WavelengthData>
312 ';
313 }
314 # Output reflection
315 print
316 ' <WavelengthData>
317 <LayerNumber>System</LayerNumber>
318 <Wavelength unit="Integral">Visible</Wavelength>
319 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
320 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
321 <WavelengthDataBlock>
322 ';
323 print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
324 print
325 ' <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
326 <ScatteringDataType>BRDF</ScatteringDataType>
327 <ScatteringData>
328 ';
329 system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
330 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
331 "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
332 "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
333 die "Failure running rttree_reduce" if ( $? );
334 print
335 ' </ScatteringData>
336 </WavelengthDataBlock>
337 </WavelengthData>
338 ';
339 } # end of ttree_out()
340
341 #------------- End of do_tree_bsdf() & subroutines -------------#
342
343 #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
344 sub do_matrix_bsdf {
345 # Set up sampling of portal
346 # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
347 $tcal = '
348 DEGREE : PI/180;
349 sq(x) : x*x;
350 Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
351 Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
352 Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
353 Kmax : Kaccum(Knaz(0));
354 Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r);
355 Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin));
356 Kcol = Kbin - Kaccum(Krow-1);
357 Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
358 Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
359 sin_kpol = sin(Kpol);
360 Dx = cos(Kazi)*sin_kpol;
361 Dy = sin(Kazi)*sin_kpol;
362 Dz = sqrt(1 - sin_kpol*sin_kpol);
363 KprojOmega = PI * if(Kbin-.5,
364 (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
365 1 - sq(cos(Kpola(1)*DEGREE)));
366 ';
367 # Compute Klems bin from exiting ray direction (forward or backward)
368 $kcal = '
369 DEGREE : PI/180;
370 abs(x) : if(x, x, -x);
371 Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
372 posangle(a) : if(-a, a + 2*PI, a);
373 Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
374 kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
375 knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
376 kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
377 kfindrow(r, pol) : if(r-kpola(0)+.5, r,
378 if(pol-kpola(r), kfindrow(r+1, pol), r) );
379 kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0);
380 kbin2(pol,azi) = select(kfindrow(1, pol),
381 kazn(azi,360/knaz(1)),
382 kaccum(1) + kazn(azi,360/knaz(2)),
383 kaccum(2) + kazn(azi,360/knaz(3)),
384 kaccum(3) + kazn(azi,360/knaz(4)),
385 kaccum(4) + kazn(azi,360/knaz(5)),
386 kaccum(5) + kazn(azi,360/knaz(6)),
387 kaccum(6) + kazn(azi,360/knaz(7)),
388 kaccum(7) + kazn(azi,360/knaz(8)),
389 kaccum(8) + kazn(azi,360/knaz(9))
390 );
391 kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
392 ';
393 my $ndiv = 145;
394 # Compute scattering data using rtcontrib
395 my @tfarr;
396 my @rfarr;
397 my @tbarr;
398 my @rbarr;
399 my $cmd;
400 my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
401 "-e '$kcal' -b kbin -bn $ndiv " .
402 "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
403 my $rccmd = "rcalc -e '$tcal' " .
404 "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
405 q{-if3 -e 'oval=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' } .
406 q[-o '${ oval },'];
407 if ( $doforw ) {
408 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
409 "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
410 "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
411 "-e 'zp:$dim[4]' " .
412 q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
413 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
414 "| $rtcmd";
415 system "$cmd" || die "Failure running: $cmd\n";
416 @tfarr = `$rccmd $td/$fmodnm.flt`;
417 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
418 @rfarr = `$rccmd $td/$bmodnm.flt`;
419 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
420 }
421 if ( $doback ) {
422 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
423 "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
424 "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
425 "-e 'zp:$dim[5]' " .
426 q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
427 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
428 "| $rtcmd";
429 system "$cmd" || die "Failure running: $cmd\n";
430 @tbarr = `$rccmd $td/$bmodnm.flt`;
431 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
432 @rbarr = `$rccmd $td/$fmodnm.flt`;
433 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
434 }
435 # Output angle basis
436 print
437 ' <DataDefinition>
438 <IncidentDataStructure>Columns</IncidentDataStructure>
439 <AngleBasis>
440 <AngleBasisName>LBNL/Klems Full</AngleBasisName>
441 <AngleBasisBlock>
442 <Theta>0</Theta>
443 <nPhis>1</nPhis>
444 <ThetaBounds>
445 <LowerTheta>0</LowerTheta>
446 <UpperTheta>5</UpperTheta>
447 </ThetaBounds>
448 </AngleBasisBlock>
449 <AngleBasisBlock>
450 <Theta>10</Theta>
451 <nPhis>8</nPhis>
452 <ThetaBounds>
453 <LowerTheta>5</LowerTheta>
454 <UpperTheta>15</UpperTheta>
455 </ThetaBounds>
456 </AngleBasisBlock>
457 <AngleBasisBlock>
458 <Theta>20</Theta>
459 <nPhis>16</nPhis>
460 <ThetaBounds>
461 <LowerTheta>15</LowerTheta>
462 <UpperTheta>25</UpperTheta>
463 </ThetaBounds>
464 </AngleBasisBlock>
465 <AngleBasisBlock>
466 <Theta>30</Theta>
467 <nPhis>20</nPhis>
468 <ThetaBounds>
469 <LowerTheta>25</LowerTheta>
470 <UpperTheta>35</UpperTheta>
471 </ThetaBounds>
472 </AngleBasisBlock>
473 <AngleBasisBlock>
474 <Theta>40</Theta>
475 <nPhis>24</nPhis>
476 <ThetaBounds>
477 <LowerTheta>35</LowerTheta>
478 <UpperTheta>45</UpperTheta>
479 </ThetaBounds>
480 </AngleBasisBlock>
481 <AngleBasisBlock>
482 <Theta>50</Theta>
483 <nPhis>24</nPhis>
484 <ThetaBounds>
485 <LowerTheta>45</LowerTheta>
486 <UpperTheta>55</UpperTheta>
487 </ThetaBounds>
488 </AngleBasisBlock>
489 <AngleBasisBlock>
490 <Theta>60</Theta>
491 <nPhis>24</nPhis>
492 <ThetaBounds>
493 <LowerTheta>55</LowerTheta>
494 <UpperTheta>65</UpperTheta>
495 </ThetaBounds>
496 </AngleBasisBlock>
497 <AngleBasisBlock>
498 <Theta>70</Theta>
499 <nPhis>16</nPhis>
500 <ThetaBounds>
501 <LowerTheta>65</LowerTheta>
502 <UpperTheta>75</UpperTheta>
503 </ThetaBounds>
504 </AngleBasisBlock>
505 <AngleBasisBlock>
506 <Theta>82.5</Theta>
507 <nPhis>12</nPhis>
508 <ThetaBounds>
509 <LowerTheta>75</LowerTheta>
510 <UpperTheta>90</UpperTheta>
511 </ThetaBounds>
512 </AngleBasisBlock>
513 </AngleBasis>
514 </DataDefinition>
515 ';
516 if ( $doforw ) {
517 print
518 ' <WavelengthData>
519 <LayerNumber>System</LayerNumber>
520 <Wavelength unit="Integral">Visible</Wavelength>
521 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
522 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
523 <WavelengthDataBlock>
524 <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
525 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
526 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
527 <ScatteringDataType>BTDF</ScatteringDataType>
528 <ScatteringData>
529 ';
530 # Output front transmission (transposed order)
531 for (my $od = 0; $od < $ndiv; $od++) {
532 for (my $id = 0; $id < $ndiv; $id++) {
533 print $tfarr[$ndiv*$id + $od];
534 }
535 print "\n";
536 }
537 print
538 ' </ScatteringData>
539 </WavelengthDataBlock>
540 </WavelengthData>
541 <WavelengthData>
542 <LayerNumber>System</LayerNumber>
543 <Wavelength unit="Integral">Visible</Wavelength>
544 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
545 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
546 <WavelengthDataBlock>
547 <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
548 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
549 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
550 <ScatteringDataType>BRDF</ScatteringDataType>
551 <ScatteringData>
552 ';
553 # Output front reflection (transposed order)
554 for (my $od = 0; $od < $ndiv; $od++) {
555 for (my $id = 0; $id < $ndiv; $id++) {
556 print $rfarr[$ndiv*$id + $od];
557 }
558 print "\n";
559 }
560 print
561 ' </ScatteringData>
562 </WavelengthDataBlock>
563 </WavelengthData>
564 ';
565 }
566 if ( $doback ) {
567 print
568 ' <WavelengthData>
569 <LayerNumber>System</LayerNumber>
570 <Wavelength unit="Integral">Visible</Wavelength>
571 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
572 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
573 <WavelengthDataBlock>
574 <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
575 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
576 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
577 <ScatteringDataType>BTDF</ScatteringDataType>
578 <ScatteringData>
579 ';
580 # Output back transmission (transposed order)
581 for (my $od = 0; $od < $ndiv; $od++) {
582 for (my $id = 0; $id < $ndiv; $id++) {
583 print $tbarr[$ndiv*$id + $od];
584 }
585 print "\n";
586 }
587 print
588 ' </ScatteringData>
589 </WavelengthDataBlock>
590 </WavelengthData>
591 <WavelengthData>
592 <LayerNumber>System</LayerNumber>
593 <Wavelength unit="Integral">Visible</Wavelength>
594 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
595 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
596 <WavelengthDataBlock>
597 <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
598 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
599 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
600 <ScatteringDataType>BRDF</ScatteringDataType>
601 <ScatteringData>
602 ';
603 # Output back reflection (transposed order)
604 for (my $od = 0; $od < $ndiv; $od++) {
605 for (my $id = 0; $id < $ndiv; $id++) {
606 print $rbarr[$ndiv*$id + $od];
607 }
608 print "\n";
609 }
610 print
611 ' </ScatteringData>
612 </WavelengthDataBlock>
613 </WavelengthData>
614 ';
615 }
616 }
617 #------------- End of do_matrix_bsdf() --------------#